require 'active_support'
require 'active_support/core_ext/object'
require 'base64'
require 'pvdgm-bs-client/beanstalk_api_options'
require 'pvdgm-bs-client/base_resource'

# Load all the prompters
Dir.glob(File.join(File.dirname(__FILE__), 'pvdgm-bs-client/prompters/*.rb')).each do | prompter_path |
  require File.join('pvdgm-bs-client/prompters', File.basename(prompter_path))
end

# Load all the resources
Dir.glob(File.join(File.dirname(__FILE__), 'pvdgm-bs-client/resources/*.rb')).each do | resource_path |
  require File.join('pvdgm-bs-client/resources', File.basename(resource_path))
end
