module TubePrompter

  def tube_name(allow_none=false)
    return options[:tube] if options[:tube]
    return options[:tube] = ENV['TUBE_NAME'] if ENV['TUBE_NAME']
    return options[:tube] = prompt_for_tube_name(allow_none)
  end

  private

  def prompt_for_tube_name(allow_none)
    result = get("beanstalk/tubes")

    # Build a menu of the tube names
    puts
    return prompter.choose do | menu |
      menu.prompt = "Select the beanstalk tube: "
      menu.choice("No Selection") { -1 } if allow_none
      result.each do | tube_name |
        menu.choice(tube_name) { tube_name }
      end
    end
  end

end
